; Comando C:TABELA le um arquivo TEXTO e desenha uma tabela no AutoCAD
;VERSAO 1.03

(defun C:TABELA ( )

;MUDA A CONFIGURACAO PARA FORMATAR AS CASAS DECIMAIS

;OBS: estas variaveis sao restauradas no final do programa
  
(SETQ R-LUPREC   (GETVAR "LUPREC"  )) (SETVAR "LUPREC" 3 )
(SETQ R-DIMDEC   (GETVAR "DIMDEC"  )) (SETVAR "DIMDEC" 3 )
(SETQ R-DIMTDEC  (GETVAR "DIMTDEC"  )) (SETVAR "DIMTDEC" 3 )
(SETQ R-DIMZIN   (GETVAR "DIMZIN"  )) (SETVAR "DIMZIN" 1 )

;pega o estilo e layer correntes 
  
(setq oldlayer (getvar "CLAYER"))
(setq oldstyle (getvar "TEXTSTYLE"))

  
;CRIA UM ESTILO "TABELA" com fonte ARIAL
  
(command "-style" "TABELA" "arial" "" "" "" "n" "n")
  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  
 ; Entrada de dados
  ; Seleciona nome do arquivo a partir de um dialog box:
  ; - a partir do diretorio corrente
  ; - com extensao .TXT
  ; - busca apenas para abertura
  
  (setq NOME (getfiled "LE TEXTO" "" "TXT" (+ 2 4 )))
 
 ; Verifica se o NOME foi fornecido
  (if NOME
    ; Solicita ponto de insercao
    (setq PTI (getpoint "\nPonto de insercao do texto: "))
  )
  
 ; Verifica se todos os dados foram fornecidos
 (if (and NOME PTI) ;
  (progn

;faz um zoom no ponto de insercao
    
(command "zoom" "s" 10)
(command "zoom" "c" pti 10)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    (setq x (car pti))
    (setq y (cadr pti))

;configuracao da tabela;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    (setq e  20) ;espaco entre as colunas
    (setq tt 2)  ;tamanho do texto
    (setq l 6)   ;altura da linha

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    (setq j y);variaveis temporarias
    (setq k x)

;define os pontos de insercao horizontal do texto e do titulo da tabela

    (setq x1 (-  x 10))  
    (setq x2 (+  x e))
    (setq x3 (+  x2 e))
    (setq x4 (+  x3 e))
    (setq x5 (+  x4 e))
    (setq x6 (+  x5 e))
    (setq x7 (+  x6 e))
    (setq x8 (+  x7 e)) 
    (setq x9 (+  x8 10))
    (setq x10 (+  x e))

;deslocamento acima do ponto de insercao do texto
;para desenhar a tabela

    (setq y1 (+  y l))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;deslocamento abaixo do ponto de insercao do texto
;para desenhar a tabela

    (setq y2 (- y l))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    (setq y3 (+ y l))
    (setq y4 (+ y l))
    
    (setq FD (open NOME "r")) ; Abre arquivo
    (if FD
      (progn

;cria um layer "TABELA_TRECHO" para insercao da tabela  
	
	(command "_layer" "M" "TABELA_TRECHO" "")
	
;insere o titulo das colunas da tabela;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	(command "TEXT" "J" "MC"(list x y3) tt "0" "HANDLE")
	(command "TEXT" "J" "MC"(list x2 y3) tt"0" "TRECHO")
	(command "TEXT" "J" "MC"(list x3 y3) tt "0" "PROF1" )
	(command "TEXT" "J" "MC"(list x4 y3) tt "0" "PROF2")
	(command "TEXT" "J" "MC"(list x5 y3) tt "0" "BASE")
	(command "TEXT" "J" "MC"(list x6 y3) tt "0" "NUMDUTOS")
	 (command "TEXT" "J" "MC"(list x7 y3) tt "0" "DIAM")
	(command "TEXT" "J" "MC"(list x8 y3) tt "0" "COMPR")
	
	(setq y (- y 0.6))
      
(setq c 0)

        (while (setq REG (read-line FD))	  ; Enquanto existirem linhas
	  (progn

;corta as linhas do arquivo texto e converte para numeros;;;;;;;;;;;;;;;;
	    
	    (setq hn (rtrim (substr reg  1 16))
		           
		tr (substr reg 17 4)
	      
	 	p1(rtos (/(atof (substr reg 21 5))1000))

	 	p2(rtos (/(atof (substr reg 26 5))1000))

	     	base(rtos (/ (atof(substr reg 31 5))1000))

	      	nd(itoa(atoi(substr reg 36 3)))
	      	
  	      	d (itoa  (atoi(substr reg 39 4)))

	     	cpr  (rtos  (/(atof(substr reg 43 7))1000))   
	
	);setq
	    
;troca o ponto por virgula ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	    
(setq p1(mudaponto p1))
(setq p2(mudaponto p2))
(setq base(mudaponto base))
(setq cpr(mudaponto cpr))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	    

;insere as informacoes da tabela;;;;;;;;;;;;;;;;;;;;;;;;; 
	    
	(command "TEXT" "J" "MC" (list x y) tt "0" hn)
	(command "TEXT" "J" "MC" (list x2 y) tt "0" tr )
	(command "TEXT" "J" "MC" (list x3 y) tt "0" p1 )
	(command "TEXT" "J" "MC" (list x4 y) tt "0" p2 )
	(command "TEXT" "J" "MC" (list x5 y) tt "0" base )
   	(command "TEXT" "J" "MC" (list x6 y) tt "0" nd)
	(command "TEXT" "J" "MC" (list x7 y) tt "0" d )
	(command "TEXT" "J" "MC" (list x8 y) tt "0" cpr)
	    
	(setq y(- y l ))
	(setq y1(- y1 l))
	(setq y2(- y2 l))

(setq c (+ c 1))
	    
);progn
	    
);while
	  
        (close FD) ; Fecha arquivo


;============================================= 

;redefine as variaveis

(setq y j)
	
(setq x1 (-  x 10))
(setq x2 (+  x e))
	
(setq y1 (+  y 2.5))
(setq y2 (- y 1.5))
(setq y3 (+ y 4.5))
(setq y4 (+ y 7.5))
	
;(setq c(+ c 1))
	
(repeat c

  ;desenha as linhas horizontais
  
	(command "line" (list x1 y1 ) (list x9 y1)"")
  
	(setq y(- y l))
	(setq y1(- y1 l))
	(setq y2(- y2 l))	    
)
	
;(setq y2(+ y2 (* l )))
 	
(setq y2(+ y2 (* l )))
	
(setq y2(- y2 2))
	
(setq y4(+ y4 (/ l 2)))	
	
	;desenha o retangulo exterior a tabela
	
(command "rectangle" (list x1 y4 ) (list x9 y2))

;;;;;;;;;;;;;;;;;;;;;;;;

    (setq x1 (-  x 10))  
    (setq x2 (+  x 10))
    (setq x3 (+  x2 e))
    (setq x4 (+  x3 e))
    (setq x5 (+  x4 e))
    (setq x6 (+  x5 e))
    (setq x7 (+  x6 e))
    (setq x8 (+  x7 e)) 
    (setq x9 (+  x8 e))
    (setq x10 (+  x e))

;;;;;;;;;;;;;;;;;;;;;;;;;;;

;desenha as linhas verticais
	
(repeat 8
(command "line" (list x1 y4 ) (list x1 y2)"")
(command "")
(setq x1(+ x1 e))
)
;	(command "zoom" "c" pti 20)
	
      );if
	
      ; Messagem de erro
      (princ "\nErro na abertura do arquivo.\n") 
    )
   );if nome
 )  ;fim nome arquivo texto 

 (princ) ; limpa finalizacao de funcao



;RESTAURA OS VALORES ORIGINAIS DAS VARIAVEIS DE SISTEMA
  
(SETVAR "LUPREC"   R-LUPREC  )
(SETVAR "DIMDEC" R-DIMDEC )
(SETVAR "DIMTDEC" R-DIMTDEC )
(SETVAR "DIMZIN" R-DIMZIN )
(setvar "CLAYER" oldlayer)
(setvar "TEXTSTYLE" oldstyle)
  
  

  
);fim programa

(defun rtrim (f_string) ;removes spaces from right of string
  (setq f_loop 0)
  (setq f_len (strlen f_string))
  (while (= (ascii (substr f_string (- f_len f_loop) 1)) 32)
    (setq f_loop (1+ f_loop))
  )
  (setq f_string (substr f_string 1 (- f_len f_loop)))
)
;eg (rtrim "  trim  ") = "  trim"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun ltrim (f_string / f_loop) ;removes spaces from left of string
  (setq f_loop 1)
  (while (= (ascii (substr f_string f_loop 1)) 32)
    (setq f_loop (1+ f_loop))
  )
  (setq f_string (substr f_string f_loop (strlen f_string)))
)

;;;;;;;;;;;;;;;muda o ponto por virgula em uma string

(DEFUN mudaponto (str)
(SETQ  str2 "")
(SETQ  pos 1)
(REPEAT (STRLEN str)
(SETQ chstr (SUBSTR str pos 1))
(IF (= chstr ".") (SETQ chstr ",") )
(SETQ str2 (STRCAT str2 chstr))
(SETQ pos   (+ pos 1))
)
str2
)

;;;;;;;;;;;;;;;



;====================================================================================
	registro de alteracoes
;====================================================================================
;27/04/05 alteracao:o diametro  um numero inteiro(casas decimais suprimidas).   
;28/04/05 alteracao:o texto foi centralizado na coluna
;06/05/05 formatadas as casas decimais (completadas com zeros)
;06/05/05 criado um estilo "TABELA" com fonte arial
